<?php
/**
* gzfixtitleamp.php
*	(C) December 2009 Gero Zahn gerozahn -at- gerozahn.de
* license		GNU/GPL, see LICENSE.php
*/

# finds &amp;amp; occurrences inside the <title>...</title> tag
# and replaces them with a correct &amp;

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin');

/**
* Joomla! replacePNG Plugin
*
* @package 		Joomla
* @subpackage	System
*/
class plgSystemGZFixTitleAmp extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @param	object		$subject The object to observe
	  * @param 	array  		$config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgSystemGZFixTitleAmp(&$subject, $config)  {
		parent::__construct($subject, $config);
	}

	/**
     * Do it
     */
	function onAfterRender()
	{
		$app =& JFactory::getApplication();

		if($app->getName() != 'site') {
			return true;
		}

		//Replace src links
		$base   = JURI::base(true).'/';
		$buffer = JResponse::getBody();

		$searchfor = "/(<title>.*)&amp;amp;(.*<\/title>)/i"; # RegEx to find "&amp;amp;" in <title>...</title>
		$replaceby = "$1&amp;$2"; # Chunk from the beginning + correct &amp; + chunk from the end

		while (preg_match($searchfor,$buffer)) { # In case of multiple ampersands
			$buffer = preg_replace( $searchfor, $replaceby, $buffer ); # This is it. RIP MJ.
		}

		JResponse::setBody($buffer);
		return true;

	}

}
